/*
 *  OpenGLDraw2D.h
 *  SampleScreenSaver
 *
 *  Created by гык-sse2 on 11.07.10.
 *  Copyright 2010 Гимназия 1542. All rights reserved.
 *
 */

#ifndef _CONSOLATION_H
#define _CONSOLATION_H

#ifdef __APPLE__
	#include <GLUT/glut.h>
	#include "SDL.h"
#else
#ifdef WIN32
	#include "SDL.h"
	#include <stdio.h>
	#include "glut.h"
	#pragma warning (disable:4996)
#else
	#include <GL/glut.h>
	#include "SDL/SDL.h"
#endif
#endif
#include <math.h>
#include <stdarg.h>

enum PTFillStyle	{SOLID_FILL, NONE};
enum PTColor		{BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, BROWN, LIGHTGRAY, DARKGRAY, LIGHTBLUE, LIGHTGREEN, LIGHTCYAN, LIGHTRED, LIGHTMAGENTA, YELLOW, WHITE};

//Графические функции
//graphics.h
void	initgraph		(int hsize, int vsize, bool fullscreen, int* argc, char** argv);	//Инициализация графики (несовместима с борландом!)
void	closegraph		();											//Завершение графики
void	setbkcolor		(PTColor color);							//Установка цвета фона
void	setcolor		(PTColor color);							//Установка цвета рисования
void	cleardevice		();											//Очистка экрана
void	putpixel		(float x1, float y1);						//Рисование точки
void	line			(float x1, float y1, float x2, float y2);	//Рисование линии
void	bar				(float x1, float y1, float x2, float y2);	//Рисование прямоугольника
void	bar3d			(float x1, float y1, float x2, float y2, float depth, bool topflag);	//Рисование прямоугольного параллелепипеда
void	fillpoly		(int n, float* array);						//Рисование многоугольника
void	outtext			(const char* string);						//Вывод текста в текущих координатах
void	outtextxy		(float x, float y, const char* string);		//Вывод текста в точке с заданными координатами
void	setfillstyle	(PTFillStyle newStyle, PTColor newColor);	//Установка стиля заполнения
void	fillellipse		(float x0, float y0, float r1, float r2);	//Рисование эллипса

//Вспомогательные функции
void	catchevents		();											//Обработка некоторых событий (нужно для bioskey и закрытия программы по крестику


//Текстовые функции 
//conio.h, stdio.h
void	gotoxy			(float x, float y);							//Переход в точку
void	clrscr			();											//Очистка экрана и сброс текстовых координат
char	getch			();											//Чтение символа
int		ptputs			(const char* string);						//Вывод строки
char*	ptgets			(char* string);
char	getche			();											//Чтение символа с выводом на экран
int		putch			(char symbol);								//Вывод символа
void	ptprintf		(const char* format, ...);					//Форматированный вывод
#ifndef WIN32
void	ptscanf			(const char* format, ...);					//Форматированный ввод (не работает в Windows из-за отсутствия функции vsscanf)
#endif

//dos.h
void	delay			(int ms);									//Задержка в миллисекундах
int		bioskey			(int command);								//Биоскей

//Эти функции не входят в стандарты, но это полезное дополнение, позволяющее использовать аппаратное ускорение для простых операций
void	PTPointArray		(float* array, int n);					//Рисование массива точек
void	PTLinedPointArray	(float* array, int n);					//Рисование массива точек, соединенных линиями

#endif //_CONSOLATION_H
